I8259_0 	EQU 	200H
I8259_1 	EQU 	201H
I8255_A	 equ 	210H
I8255_B	 equ 	211H
I8255_C 	equ		212H
I8255_CTR	 equ		213H
I8254_0 	equ		220H
I8254_1 	equ		221H
I8254_CTR	EQU  223H
IOAD_S EQU 250H

data segment
buf db 33H
DIR DB 0
speed db 0
data ends

ss_seg segment page 
db 100 dup(?) 
ss_seg ends

code segment
assume cs:code,ds:data,ss:ss_seg

start : CLI
MOV	 AX, DATA
MOV 	DS, AX
MOV 	DX,I8259_0 ;ICW1
MOV	AL, 00010011B
OUT 	DX, AL
MOV 	DX,I8259_1
MOV 	AL,00001000B
OUT		DX,AL
MOV	AL,00000001B
OUT		DX,AL


PUSH	DS	
MOV	AX, 0	
MOV	DS,AX	
LEA	AX,CS:INT_PROC	;写中断向?
MOV	SI,08H	;BASE = 08	
ADD	SI, SI	;TYPE NUM	
ADD	SI,SI	;X4	;将中断服务程序入口地址的偏移地址存放到物理地址?XSI的字单元之中
MOV	DS:[SI],AX	;置入中断服务程序入口地址的偏移量	
PUSH	CS	
POP		AX	
MOV	DS:[SI+2],AX	;置入中断服务程序入口地址的段基址?
POP		DS	
IN		AL, DX	;OCW1	
AND	AL, 11111110B	
OUT		DX,AL	

mov		dx,I8255_CTR	;指向8255的控制口	
mov		al, 8bh	;设定A口为方式0输出，C、B口方?输入	
out		dx, al	;写入控制?

mov		buf,33h	;buf=33H 初始相序0011B	
mov		dx,I8254_CTR	;?253计数?为方?	
mov		al, 36h	
out		dx,al	
mov		dx,I8254_0	
mov		ax, 100	;写入计数器初?00	

out		dx,al	
mov		al, ah	
out		dx,al	
mov		dx,I8254_CTR	
mov		al,74h	;设计数器1为工作方?	
out		dx,al	
mov		dx,I8254_1	
mov		al,speed	;写入计数器CNT1初�?必须大于35)	
out		dx, al	
mov		al,ah	
out		dx,al	
out1:	mov		al, buf	
mov		dx,I8255_A	
out		dx, al	;输出步进电机的相序代?
STI


LLL: nop


JMP LLL



INT_PROC PROC far	
push	AX
	push	CX	
	PUSH	BX
lop:	
MOV DX,IOAD_S		;【AD接收速度信号
OUT DX,AL
MOV DX,IOAD_S+2
 LOP1:IN AL,DX
TEST AL,01H
JZ LOP1
MOV DX,IOAD_S+1
IN AL,DX
MOV speed,AL     ;AD接收速度信号?

MOV		DX,I8255_B		;【I8255_B接收转向信号
IN		AL,DX
MOV		DIR,AL       ;I8255_B接收转向信号?

mov	al, buf			;【判断方?
mov bl,dir
and bl,80h
cmp bl,80h
je dirb
cmp bl,80h
jne dirf
dirb:ror al,1
jmp nx1
dirf:rol  al,1
jmp nx1				
nx1:mov		buf,al		;判断方向?

mov		dx,I8254_1	           ;【改变步进电机转动速度
	mov	ah,0			
mov		al,speed	;写入计数器CNT1初�?必须大于35)	

out		dx, al	
mov		al,ah	
out		dx,al



;改变步进电机转动速度?

MOV	 dx,I8255_A		;【输出步进电机的相序代码	
mov	al,buf
out	dx,al						;输出步进电机的相序代??

mov		al,20h
mov		DX,I8259_0	
out dx,al					
				




pop	CX	
pop	AX	
POP BX
sti 
IRET
INT_PROC ENDP
code ends
end start
